\def\filedate{2018/06/26}
\def\fileversion{1.0-dev}

\NeedsTeXFormat{LaTeX2e}
\ProvidesPackage{beamerthemeustutt}[\filedate\space Version \fileversion\space by Philipp Tempel <philipp.tempel@isw.uni-stuttgart.de>]


\RequirePackage{etoolbox}
\RequirePackage{ifdraft}
\RequirePackage{pgfopts}
\RequirePackage{xparse}



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Amsmath
\PassOptionsToPackage{%
  centertags,% (default) center tags vertically
%  tbtags,% 'Top-or-bottom tags': For a split equation, place equation numbers level with the last (resp. first) line, if numbers are on the right (resp. left).
  sumlimits,% (default) Place the subscripts and superscripts of summation symbols above and below
%  nosumlimits,% Always place the subscripts and superscripts of summation-type symbols to the side, even in displayed equations.
  intlimits,% Like sumlimits, but for integral symbols.
%  nointlimits,% (default) Opposite of intlimits.
  namelimits,% (default) Like sumlimits, but for certain 'operator names' such as det, inf, lim, max, min, that traditionally have subscripts placed underneath when they occur in a displayed equation.
%  nonamelimits,% Opposite of namelimits.
%  leqno,% Place equation numbers on the left.
  reqno,% Place equation numbers on the right.
%  fleqn,% Position equations at a fixed indent from the left margin rather than centered in the text column.
}{amsmath}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Babel
\PassOptionsToPackage{%
}{babel}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Babelbib
\PassOptionsToPackage{%
  fixlanguage,%
}{babelbib}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Cleveref
\PassOptionsToPackage{%
  capitalise,%
}{cleveref}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Eurosym
\PassOptionsToPackage{%
  gen,%
}{eurosym}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Footmisc
\PassOptionsToPackage{%
  hang,%
  multiple,%
}{footmisc}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Glossaries
\PassOptionsToPackage{%
  acronyms,%
  toc,%
  xindy,%
  nomain,%
  shortcuts,%
  nopostdot,%
}{glossaries}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Graphicx
\PassOptionsToPackage{%
  final,%
}{graphicx}


% We need to explicitely tell hyperref that we are in draft or final mode
% @see https://en.wikibooks.org/wiki/LaTeX/Print_version#Problems_with_draft_mode
% Draft case
\ifdraft{%
  \PassOptionsToPackage{%
    final=false,%
    draft=true,%
  }{hyperref}%
% Final case
}{%
  \PassOptionsToPackage{%
    draft=false,%
    final=true,%
  }{hyperref}%
}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Isodate
\PassOptionsToPackage{%
}{isodate}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Nth
\PassOptionsToPackage{%
  % super,%
}{nth}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% showkeys
\PassOptionsToPackage{%
  % to stop the redefinition of \ref and \pageref, and related commands from the varioref package
  notref,%
  % to stop the redefinition of \cite and related commands from the harvard and natbib packages.
  notcite,%
}{showkeys}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% SIUnitX
\PassOptionsToPackage{%
  per-mode=fraction,%
  binary-units=true,%
}{siunitx}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Todnotes
\PassOptionsToPackage{%
  obeyFinal,%
  colorinlistoftodos,%
  textsize=footnotesize,%
}{todonotes}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Url
\PassOptionsToPackage{%
  obeyspaces,%
  hyphens,%
  spaces%
}{url}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% biblatex
\PassOptionsToPackage{%
  % General configuration of biblatex
  backend=biber,%
  % backref=true,%
  style=authoryear-comp,%
  % giveninits=true,%
  % autocite=inline,%
  sorting=ynt,%
  sortcites=true,%
  %
  % Configuration of text citations
  mincitenames=1,%
  maxcitenames=2,%
  %
  % Configuration of bibliography
  maxbibnames=10,%
  doi=false,%
  isbn=false,%
  url=false,%
  natbib=true,% natbib compatibility mode (\citep and \citet still work)
}{biblatex}


% Load the language class
\RequirePackage{babel}

% This package provides expandable checks for the current language based on macro \languagename or hyphenation patterns.
% The package is part of the oberdiek bundle.
\RequirePackage{translations}

% The xspace package provides a single command that looks at what comes after it in the command stream, and decides whether to insert a space to replace one "eaten" by the TeX command decoder. The decision is based on what came after any space, not on whether there was a space (which is unknowable): so if the next thing proves to be punctuation, the chances are there was no space, but if it's a letter, there's probably a need for space. This technique is not perfect, but works in a large proportion of cases.
% The package is part of the latex-tools bundle in the LaTeX required distribution.
\RequirePackage{xspace}

% Fontspec is a package for X3LaTeX and LuaLaTeX. It provides an automatic and unified interface to feature-rich AAT and OpenType fonts through the NFSS in LaTeX running on X3TeX or LuaTeX engines.
% The package requires the l3kernel and xparse bundles from the LaTeX 3 development team.
\RequirePackage{fontspec}

\RequirePackage{amsmath}
\RequirePackage{amssymb}
\RequirePackage{mathtools}

% The package supports the Text Companion fonts, which provide many text symbols (such as baht, bullet, copyright, musicalnote, onequarter, section, and yen), in the TS1 encoding.
% Note that the package has been adopted as part of the LaTeX distribution; the reference here is to the original package, which is now little used (if at all).
\RequirePackage{textcomp}

% Tune the output format of dates according to language. This package provides ten output formats of the commands \today, \printdate, \printdate-TeX, and \daterange (partly language dependent). Formats available are: ISO (yyyy-mm-dd), numeric (e.g.,dd.\,mm.~yyyy), short (e.g.,dd.\,mm.\,yy), TeX (yyyy/mm/dd), original (e.g., dd. mmm yyyy), short original (e.g., dd. mmm yy), as well as numerical formats with Roman numerals for the month. The commands \printdate and \printdate-TeX print any date. The command \daterange prints a date range and leaves out unnecessary year or month entries. This package supports German (old and new rules), Austrian, US English, British English, French, Danish, Swedish, and Norwegian.
\RequirePackage{isodate}

% Latin modern font package
\RequirePackage{lmodern}

% This package was developed as a general solution to the problem of including graphics in LaTeX 2.09; as such there are obsolete copies to be found on the web (though no longer on the archive). These old versions should not be used with current LaTeX.
% The current 'preferred' solution is the LaTeX graphicx package, but the graphics bundle does contain a version of epsfig for use with current LaTeX.
\RequirePackage{epsfig}

% The package builds upon the graphics package, providing a key-value interface for optional arguments to the \includegraphics command. This interface provides facilities that go far beyond what the graphics package offers on its own.
% For extended documentation, see epslatex.
% The package is part of the latex-graphics bundle, which is one of the collections in the LaTeX 'required' set of packages.
\RequirePackage{graphicx}
\graphicspath{{figures/}{images/}}

%
\RequirePackage{tikz}
% PGFPlots draws high-quality function plots in normal or logarithmic scaling with a user-friendly interface directly in TeX. The user supplies axis labels, legend entries and the plot coordinates for one or more plots and PGFPlots applies axis scaling, computes any logarithms and axis ticks and draws the plots, supporting line plots, scatter plots, piecewise constant plots, bar plots, area plots, mesh-- and surface plots and some more.
% Pgfplots is based on PGF/TikZ (PGF); it runs equally for LaTeX/TeX/ConTeXt.
\RequirePackage{pgfplots}
\RequirePackage{tikzscale}
\pgfplotsset{compat=newest}
% The package provides straightforward ways to define three-dimensional coordinate frames through which to plot in TikZ. The user can specify the orientation of the main coordinate frame, and use standard TikZ commands and coordinates to render their tikzfigure. A secondary coordinate frame is provided to allow rotations and translations with respect to the main coordinate frame. In addition, the package can also handle plotting user-specified functions in spherical polar coordinates, where both the radius and fill color can be expressed as parametric functions of polar angles.
\RequirePackage{tikz-3dplot}

% The package defines new commands \Centering, \RaggedLeft, and \RaggedRight and new environments Center, FlushLeft, and FlushRight, which set ragged text and are easily configurable to allow hyphenation (the corresponding commands in LaTeX, all of whose names are lower-case, prevent hyphenation altogether).
\RequirePackage{ragged2e}

% Set the font size relative to the current font size. The basic command of the package is \relsize, whose argument is a number of \magsteps to change size; from this are defined commands \larger, \smaller, \textlarger, etc.
\RequirePackage{relsize}

% A comprehensive (SI) units package. Typesetting values with units requires care to ensure that the combined mathematical meaning of the value plus unit combination is clear. In particular, the SI units system lays down a consistent set of units with rules on how they are to be used. However, different countries and publishers have differing conventions on the exact appearance of numbers (and units). A number of LaTeX packages have been developed to provide consistent application of the various rules: SIunits, sistyle, unitsdef and units are the leading examples. The numprint package provides a large number of number-related functions, while dcolumn and rccol provide tools for typesetting tabular numbers. The siunitx package takes the best from the existing packages, and adds new features and a consistent interface. A number of new ideas have been incorporated, to fill gaps in the existing provision. The package also provides backward-compatibility with SIunits, sistyle, unitsdef and units. The aim is to have one package to handle all of the possible unit-related needs of LaTeX users. The package relies on LaTeX 3 support from the l3kernel and l3packages bundles.
\RequirePackage{siunitx}

% The package enhances the quality of tables in LaTeX, providing extra commands
% as well as behind-the-scenes optimisation. Guidelines are given as to what
% constitutes a good table in this context. From version 1.61, the package
% offers longtable compatibility.
\RequirePackage{booktabs}

% Provides support for setting the spacing between lines in a document. Package
% options include singlespacing, onehalfspacing, and doublespacing.
% Alternatively, the spacing can be changed as required with the
% |\singlespacing|, |\onehalfspacing|, and |\doublespacing| commands. Other size
% spacings are also available.
\RequirePackage{setspace}

% Interpretes quotation marks " and ' and correctly typesets them. Some LaTeX-Editors however provide an option for automatically replacing the correct LaTeX code for quotes, which should be preferred.
\RequirePackage{csquotes}

% The dcolumn package makes use of the array package to define a "D" column format for use in tabular environments.
% This package is part of the tools bundle in the LaTeX required distribution.
\RequirePackage{dcolumn}

% The European currency symbol for the Euro implemented in METAFONT, using the official European Commission dimensions, and providing several shapes (normal, slanted, bold, outline). The package also includes a LaTeX package which defines the macro, pre-compiled tfm files, and documentation.
\RequirePackage{eurosym}

% This package fixes the frame numbering in beamer when using an appendix such that the slides from the appendix are not counted in the total frame number of the main part of the document. The total frame number counter is reset to 0 when entering the appendix.
% The standard usage is to include |\usepackage{appendixnumberbeamer}| in the preamble and then declare the beginning of the appendix as usual using the |\appendix| command. 
\RequirePackage{appendixnumberbeamer}

% Use biblatex, which is the (highly configurable) successor of bibtex and biber
% biber is still used though to sort the bibliography in the background.
\RequirePackage{biblatex}

% The command \url is a form of verbatim command that allows linebreaks at certain characters or combinations of characters, accepts reconfiguration, and can usually be used in the argument to another command. (The \urldef command provides robust commands that serve in cases when \url doesn't work in an argument.) The command is intended for email addresses, hypertext links, directories/paths, etc., which normally have no spaces, so by default the package ignores spaces in its argument. However, a package option "allows spaces", which is useful for operating systems where spaces are a common part of file names.
\RequirePackage{url}


\newcommand{\providelength}[1]{%
  \@ifundefined{\expandafter\@gobble\string#1}{%
    % if #1 is undefined, do \newlength
    \typeout{\string\providelength: making new length \string#1}%
    \newlength{#1}%
  }{% else check whether #1 is actually a length
    \sdaau@checkforlength{#1}%
  }%
}%

\newcommand{\sdaau@checkforlength}[1]{%
  % get the first five characters from \meaning#1
  \edef\sdaau@temp{\expandafter\sdaau@getfive\meaning#1TTTTT$}%
  % compare with the string "\skip"
  \ifx\sdaau@temp\sdaau@skipstring%
    \typeout{\string\providelength: \string#1 already a length}%
  \else%
    \@latex@error{%
      \string#1 illegal in \string\providelength%
    }{%
      \string#1 is defined, but not with \string\newlength%
    }%
  \fi%
}%
\def\sdaau@getfive#1#2#3#4#5#6${#1#2#3#4#5}
\edef\sdaau@skipstring{\string\skip}


\pgfkeys{/ustutt/.cd,%
  .search also={%
    /ustutt/inner,%
    /ustutt/outer,%
    /ustutt/color,%
    /ustutt/font,%
  }%
}
\pgfkeys{%
  /ustutt/titleformat plain/.cd,%
    .is choice,%
    regular/.code={%
      \let\ustutt@plaintitleformat\@empty%
      \setbeamerfont{standout}{shape=\normalfont}%
    },
    smallcaps/.code={%
      \let\ustutt@plaintitleformat\@empty%
      \setbeamerfont{standout}{shape=\scshape}%
    },
    allsmallcaps/.code={%
      \let\ustutt@plaintitleformat\MakeLowercase%
      \setbeamerfont{standout}{shape=\scshape}%
      \PackageWarning{beamerthemeustutt}{%
        Be aware that titleformat plain=allsmallcaps can lead to problems%
      }
    },
    allcaps/.code={%
      \let\ustutt@plaintitleformat\MakeUppercase%
      \setbeamerfont{standout}{shape=\normalfont}%
      \PackageWarning{beamerthemeustutt}{%
        Be aware that titleformat plain=allcaps can lead to problems%
      }
    },
}
\pgfkeys{
  /ustutt/titleformat/.code=\pgfkeysalso{
      font/titleformat title=#1,%
      font/titleformat subtitle=#1,%
      font/titleformat section=#1,%
      font/titleformat frame=#1,%
      titleformat plain=#1,%
    }
}
\pgfkeys{/ustutt/.cd,%
  usetitleprogressbar/.code=\pgfkeysalso{%
    outer/progressbar=frametitle,%
  },%
  noslidenumbers/.code=\pgfkeysalso{%
    outer/numbering=none,%
  },%
  usetotalslideindicator/.code=\pgfkeysalso{%
    outer/numbering=fraction,%
  },%
  nosectionslide/.code=\pgfkeysalso{%
    inner/sectionpage=none,%
  },%
  % darkcolors/.code=\pgfkeysalso{%
  %   color/background=dark,%
  % },%
  % lightcolors/.code=\pgfkeysalso{%
  %   color/background=light,%
  % },%
  blockbg/.code=\pgfkeysalso{%
    color/block=fill,%
    inner/block=fill,%
  },%
}
\newcommand{\ustutt@setdefaults}{%
  \pgfkeys{/ustutt/.cd,%
    titleformat plain=regular,%
  }%
}
\providecommand{\tikzexternalenable}{}
\providecommand{\tikzexternaldisable}{}
\usecolortheme{ustutt}
\useinnertheme{ustutt}
\useoutertheme{ustutt}
\usefonttheme{ustutt}
\AtEndPreamble{%
  \@ifpackageloaded{pgfplots}{%
    \RequirePackage{pgfplotsthemeustutt}%
  }{%
  }
}
\newcommand{\ustuttset}[1]{\pgfkeys{/ustutt/.cd,#1}}

\newcommand{\ustuttreducelistspacing}{\vspace{-\topsep}}

\newcommand{\highlight}[1]{%
  \color{UStuttAccent1}{#1}%
}

\ustutt@setdefaults

\ProcessPgfOptions{/ustutt}

\endinput
